;;;  This is an adaptation of the elevator that appears in the IJCAI-97
;;;  paper on ConGolog.  The code is in reactive-elevator-run.scm.

(include "reactive-elevator-run.scm")

;;;  In this version, ERGO is used with a separate TCP action server program
;;;     - exogenous actions for ERGO can be typed in here
;;;     - ordinary and exogenous action are sent to the server on port 8123 

;;;  Note the action server program must be running before calling ergo-do.
;;;  It reads actions generated by ERGO and must acknowledge with "ok"

(define-interface 'in read-exogenous)

(define-interface 'out
  (let ((ports (open-tcp-client 8123)))
    (lambda (act) 
      (displayln act (cadr ports))
      (or (eq? (read (car ports)) 'ok) (error "bad read from server")))))

(define (main) (ergo-do #:mode 'online control))
